import { QueryList, OnInit } from '@angular/core';
import { Subject } from 'rxjs';
import { services, filters } from 'typescript-angular-utilities';
import __object = services.object;
import __array = services.array;
import __genericSearchFilter = services.genericSearchFilter;
import { IDataSource } from './dataSources/index';
import { DataPager } from './paging/dataPager/dataPager.service';
import { IColumn } from './column';
import { ISortDirections } from './sorts/index';
import { CardComponent } from './card/card';
import { CardContentTemplate, CardFooterTemplate } from '../cards/index';
import { ContainerHeaderTemplate, ContainerFooterTemplate, ColumnContentTemplate } from './templates/index';
import { ColumnHeaderTemplate } from './templates/columnHeader.template';
import { ISaveAction } from '../form/form';
import { CardContainerBuilder, CardContainerType } from './builder/cardContainerBuilder.service';
export interface ICardContainerInputs {
    builder: string;
    save: string;
}
export declare const cardContainerInputs: ICardContainerInputs;
export declare const defaultMaxColumnSorts: number;
export declare class CardContainerComponent<T> implements OnInit {
    builder: CardContainerBuilder;
    save: ISaveAction<any>;
    dataSource: IDataSource<T>;
    filters: filters.IFilter[];
    searchFilter: __genericSearchFilter.IGenericSearchFilter;
    paging: boolean;
    columns: IColumn<any>[];
    clickableCards: boolean;
    maxColumnSorts: number;
    permanentFooters: boolean;
    saveWhenInvalid: boolean;
    sortDirection: ISortDirections;
    numberSelected: number;
    numberSelectedChanges: Subject<number>;
    object: __object.IObjectUtility;
    array: __array.IArrayUtility;
    injectedPager: DataPager;
    type: CardContainerType;
    containerHeader: ContainerHeaderTemplate;
    containerFooter: ContainerFooterTemplate;
    cardContent: CardContentTemplate;
    cardFooter: CardFooterTemplate;
    columnTemplates: QueryList<ColumnContentTemplate>;
    columnHeaders: QueryList<ColumnHeaderTemplate>;
    cardChildren: QueryList<CardComponent<T>>;
    cards: CardComponent<T>[];
    constructor(object: __object.IObjectUtility, array: __array.IArrayUtility, pager: DataPager);
    ngOnInit(): void;
    openCard(): boolean;
    sort(column: IColumn<any>): void;
    private syncFilters();
    private setupPaging();
    private buildColumnSizes();
    private lookupColumn(label);
    private buildSecondarySorts(direction, secondarySorts);
    private updateVisualColumnSorting();
    private updateVisualSortIndicator(sort);
    private clearVisualSortIndicator(sort);
    private getColumnTemplate(columnName);
}
