import { services, filters } from 'typescript-angular-utilities';
import __array = services.array;
import __object = services.object;
import __synchronizedRequests = services.synchronizedRequests;
import { IServerSearchFunction, IServerSearchParams } from '../asyncTypes';
import { IAsyncDataSource, AsyncDataSource } from '../asyncDataSource.service';
import { IDataSourceProcessor } from '../dataSourceProcessor.service';
export interface ISmartDataSource<TDataType> extends IAsyncDataSource<TDataType> {
    filters: filters.ISerializableFilter<any>[];
}
export declare class SmartDataSource<TDataType> extends AsyncDataSource<TDataType> {
    private object;
    throttled: boolean;
    appliedFilters: {
        [index: string]: any;
    };
    private _filters;
    private subscriptions;
    private throttleLimit;
    constructor(getDataSet: IServerSearchFunction<TDataType>, dataSourceProcessor: IDataSourceProcessor, array: __array.IArrayUtility, object: __object.IObjectUtility, synchronizedRequestsFactory: __synchronizedRequests.ISynchronizedRequestsFactory);
    filters: filters.IFilter[];
    onSortChange(): void;
    refresh(): void;
    protected getParams(): IServerSearchParams;
    private updateAppliedFilters();
    private setupSubscriptions();
    private onFilterChange(filter);
    protected resolveReload(result: any): void;
}
