import { services } from 'typescript-angular-utilities';
import __object = services.object;
import __transform = services.transform;
import { IFilterOption, IFilterGroup, FilterGroup } from '../filterGroup.service';
export interface IRangeFilterGroupSettings<TItemType> {
    label: string;
    type: string;
    getValue: {
        (item: TItemType): number;
    } | string;
    options: IRangeFilterOptionSettings[];
}
export interface IRangeFilterOptionSettings {
    label: string;
    highInclusive?: number;
    highExclusive?: number;
    lowInclusive?: number;
    lowExclusive?: number;
}
export interface IRangeFilterOption extends IFilterOption {
    highInclusive?: number;
    highExclusive?: number;
    lowInclusive?: number;
    lowExclusive?: number;
}
export interface IRangeFilterGroup extends IFilterGroup {
    options: IRangeFilterOption[];
    serialize(): IRangeFilterValue;
}
export interface IRangeFilterValue {
    highInclusive?: number;
    highExclusive?: number;
    lowInclusive?: number;
    lowExclusive?: number;
}
export declare class RangeFilterGroup extends FilterGroup implements IRangeFilterGroup {
    private getValue;
    transformService: __transform.ITransformService;
    constructor(settings: IRangeFilterGroupSettings<any>, object: __object.IObjectUtility, transformService: __transform.ITransformService);
    serialize(): IRangeFilterValue;
    private buildRangeOption(option);
    private isNullOption(option);
}
