import { services } from 'typescript-angular-utilities';
import __notification = services.notification;
import { IWaitValue } from '../busy/busy';
import { FormService } from '../../services/form/form.service';
import { IControlGroup } from '../../types/formValidators';
export interface IBaseFormInputs {
    save: string;
}
export declare const baseInputs: IBaseFormInputs;
export interface ISaveAction<T> {
    (data: T): IWaitValue<T>;
}
export declare class FormComponent {
    save: ISaveAction<any>;
    form: IControlGroup;
    private notification;
    private formService;
    dirty: boolean;
    constructor(notification: __notification.INotificationService, formService: FormService, parentForm: FormComponent);
    submit(): boolean;
    submitAndWait(): IWaitValue<any>;
    validate(): boolean;
    saveForm(): IWaitValue<any>;
    markAsPristine(): void;
    private showErrors();
    private resetAfterSubmit(waitOn);
}
